	include	"tios.h"
	include	"util.h"
	include	"linelib.h"
	include	"graphlib.h"
	
	xdef	_main
	xdef	_comment
	xdef	_ti89

WrtStr macro
	move.w	\3,-(a7)
	pea	\4(pc)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	tios::DrawStrXY
	lea	10(a7),a7
	ENDM

Curser	macro
	move.w	\1,d0	;x
	move.w	\2,d1	;y
	move.w	#6,d2
	move.w	#6,d3
	move.w	#0,d4
	jsr	graphlib::fill
	ENDM


Drwlne macro
	move.w	\4,d3
	move.w	\3,d2
	move.w	\2,d1
	move.w	\1,d0
	lea	LCD_MEM,a0
	jsr	linelib::fline
	ENDM

_main:
	jsr	util::zap_screen
	move.w	#30,d0
	move.w	#0,d1
	move.l	#plane1,a0
	jsr	graphlib::put_sprite
	jsr	util::idle_loop


	move.w	#0,d4
	jsr	util::zap_screen
	bra	HLine

Start:
			;black
	Curser	#49,#1
	Curser	#97,#1
	Curser	#105,#1
	Curser	#113,#1
	Curser	#121,#1

	Curser	#9,#9
	Curser	#17,#9
	Curser	#25,#9
	Curser	#41,#9
	Curser	#49,#9
	Curser	#57,#9
	Curser	#73,#9
	Curser	#89,#9
	Curser	#97,#9
	Curser	#105,#9
	Curser	#113,#9
	Curser	#121,#9

	Curser	#9,#17
	Curser	#25,#17
	Curser	#89,#17
	Curser	#97,#17
	Curser	#105,#17
	Curser	#113,#17
	Curser	#121,#17

	Curser	#41,#25
	Curser	#57,#25
	Curser	#73,#25
	Curser	#121,#25

	Curser	#9,#33
	Curser	#25,#33
	Curser	#41,#33
	Curser	#89,#33
	Curser	#97,#33
	Curser	#105,#33
	Curser	#113,#33
	Curser	#121,#33

	Curser	#9,#41
	Curser	#25,#41
	Curser	#33,#41
	Curser	#41,#41
	Curser	#57,#41
	Curser	#73,#41
	Curser	#81,#41
	Curser	#97,#41
	Curser	#105,#41
	Curser	#113,#41
	Curser	#121,#41

	Curser	#49,#49
	Curser	#57,#49
	Curser	#65,#49
	Curser	#121,#49

	Curser	#9,#57
	Curser	#17,#57
	Curser	#33,#57
	Curser	#41,#57
	Curser	#57,#57
	Curser	#65,#57
	Curser	#81,#57
	Curser	#97,#57
	Curser	#105,#57
	Curser	#113,#57
	Curser	#121,#57

	Curser	#81,#65

	Curser	#1,#73
	Curser	#9,#73
	Curser	#17,#73
	Curser	#33,#73
	Curser	#41,#73
	Curser	#57,#73
	Curser	#65,#73
	Curser	#81,#73
	Curser	#89,#73
	Curser	#105,#73
	Curser	#113,#73
	Curser	#121,#73

	Curser	#1,#81
	Curser	#65,#81

	move.w	#1,d5			;Initial position of curser
	move.w	#1,d6
	bsr	Write
	
Write:
	move.w	#1,-(a7)
	jsr	tios::FontSetSys
	add.l	#2,a7
	Curser	d5,d6
	jsr	util::idle_loop
	cmp.w	#264,d0
	beq	exit
	cmp.w	#338,d0
	beq	Left
	cmp.w	#344,d0
	beq	Right
	cmp.w	#337,d0
	beq	Up
	cmp.w	#340,d0
	beq	Down
	cmp.w	#61,d0
	beq	A
	cmp.w	#40,d0
	beq	B
	cmp.w	#41,d0
	beq	C
	cmp.w	#44,d0
	beq	D
	cmp.w	#47,d0
	beq	E
	cmp.w	#124,d0
	beq	F
	cmp.w	#55,d0
	beq	G
	cmp.w	#56,d0
	beq	H
	cmp.w	#57,d0
	beq	I
	cmp.w	#42,d0
	beq	J
	cmp.w	#149,d0
	beq	K
	cmp.w	#52,d0
	beq	L
	cmp.w	#53,d0
	beq	M
	cmp.w	#54,d0
	beq	N
	cmp.w	#45,d0
	beq	O
	cmp.w	#258,d0
	beq	P
	cmp.w	#49,d0
	beq	Q
	cmp.w	#50,d0
	beq	R
	cmp.w	#51,d0
	beq	S
	cmp.w	#116,d0
	beq	T
	cmp.w	#43,d0
	beq	U
	cmp.w	#48,d0
	beq	V
	cmp.w	#46,d0
	beq	W
	cmp.w	#120,d0
	beq	X
	cmp.w	#121,d0
	beq	Y
	cmp.w	#122,d0
	beq	Z
	cmp.w	#265,d0
	beq	Questions

	bra	Write

exit:
	rts

Up:	
	move.w	d5,a3
	move.w	d6,a5
	subi.w	#8,d6
	cmp.w	#-7,d6
	beq	notmove
	bra	move

Down:
	move.w	d5,a3
	move.w	d6,a5
	addi.w	#8,d6
	cmp.w	#89,d6
	beq	notmove
	bra	move

Left:
	move.w	d5,a3
	move.w	d6,a5
	subi.w	#8,d5
	cmp.w	#-7,d5
	beq	notmove
	bra	move

Right:
	move.w	d5,a3
	move.w	d6,a5
	addi.w	#8,d5
	cmp.w	#161,d5
	beq	notmove
	bra	move

notmove:
	move.w	a3,d5
	move.w	a5,d6
	Curser	d5,d6
	bra	Write

move:
	Curser	a3,a5
	bra	Write

move2:
	Curser	d5,d6
	bra	Write

Questions:
	move.w	#0,-(a7)
	jsr	tios::FontSetSys
	add.l	#2,a7

	move.w	#0,d0
	move.w	#0,d1
	move.w	#30,d2
	move.w	#128,d3
	jsr	graphlib::scrtomem
	jsr	util::zap_screen
	WrtStr	#0,#0,#1,Hor
	WrtStr	#0,#7,#1,Q1
	WrtStr	#0,#14,#1,Q2
	WrtStr	#0,#21,#1,Q3
	WrtStr	#0,#28,#1,Q4
	WrtStr	#0,#35,#1,Q5
	WrtStr	#0,#42,#1,Q6
	WrtStr	#0,#49,#1,Q7
	WrtStr	#0,#56,#1,Q8
	WrtStr	#0,#63,#1,Q9
	WrtStr	#0,#70,#1,Q91
	WrtStr	#0,#77,#1,Q92
	WrtStr	#0,#84,#1,Q93


	jsr	util::idle_loop
	jsr	util::zap_screen
	WrtStr	#0,#0,#1,Ver
	WrtStr	#0,#7,#1,Q10
	WrtStr	#0,#14,#1,Q11
	WrtStr	#0,#21,#1,Q12
	WrtStr	#0,#28,#1,Q125
	WrtStr	#0,#35,#1,Q13
	WrtStr	#0,#42,#1,Q14
	WrtStr	#0,#49,#1,Q15
	WrtStr	#0,#56,#1,Q16
	WrtStr	#0,#63,#1,Q17
	WrtStr	#0,#70,#1,Q18
	WrtStr	#0,#77,#1,Q19
	WrtStr	#0,#84,#1,Q20
	jsr	util::idle_loop
	jsr	util::zap_screen
	move.w	#0,d0
	move.w	#0,d1
	move.w	#30,d2
	move.w	#128,d3
	jsr	graphlib::memtoscr
	Curser	d5,d6,#0
	bra	Write

HLine:
	Drwlne	#0,d4,#128,d4	;x,y,x,y
	addi.w	#8,d4
	cmp.w	#96,d4
	Beq	inbetween
	bra	HLine

inbetween:	move.w	#0,d4
	bra	VLine

VLine:
	Drwlne	d4,#0,d4,#88	;x,y,x,y
	addi.w	#8,d4
	cmp.w	#136,d4
	Beq	Start
	bra	VLine

	INCLUDE	"title.asm"

A:	WrtStr	d5,d6,#0,lettera
	bra	move2
B:	WrtStr	d5,d6,#0,letterb
	bra	move2
C:	WrtStr	d5,d6,#0,letterc
	bra	move2
D:	WrtStr	d5,d6,#0,letterd
	bra	move2
E:	WrtStr	d5,d6,#0,lettere
	bra	move2
F:	WrtStr	d5,d6,#0,letterf
	bra	move2
G:	WrtStr	d5,d6,#0,letterg
	bra	move2
H:	WrtStr	d5,d6,#0,letterh
	bra	move2
I:	WrtStr	d5,d6,#0,letteri
	bra	move2
J:	WrtStr	d5,d6,#0,letterj
	bra	move2
K:	WrtStr	d5,d6,#0,letterk
	bra	move2
L:	WrtStr	d5,d6,#0,letterl
	bra	move2
M:	WrtStr	d5,d6,#0,letterm
	bra	move2
N:	WrtStr	d5,d6,#0,lettern
	bra	move2
O:	WrtStr	d5,d6,#0,lettero
	bra	move2
P:	WrtStr	d5,d6,#0,letterp
	bra	move2
Q:	WrtStr	d5,d6,#0,letterq
	bra	move2
R:	WrtStr	d5,d6,#0,letterr
	bra	move2
S:	WrtStr	d5,d6,#0,letters
	bra	move2
T:	WrtStr	d5,d6,#0,lettert
	bra	move2
U:	WrtStr	d5,d6,#0,letteru
	bra	move2
V:	WrtStr	d5,d6,#0,letterv
	bra	move2
W:	WrtStr	d5,d6,#0,letterw
	bra	move2
X:	WrtStr	d5,d6,#0,letterx
	bra	move2
Y:	WrtStr	d5,d6,#0,lettery
	bra	move2
Z:	WrtStr	d5,d6,#0,letterz
	bra	move2

Hor:	dc.b	"Across",0

Q1:	dc.b	"A fight between two armies.",0

Q2:	dc.b	"To be alive.",0

Q3:	dc.b	"This takes up 39K of you 89's memory",0

Q4:	dc.b	"The T in TI stands for",0

Q5:	dc.b	"To blow up (like a volcano).",0

Q6:	dc.b	"You need this to run ASM programs.",0

Q7:	dc.b	"The 6th planet in our solar system.",0

Q8:	dc.b	"The button you hit to get out of a program.",0

Q9:	dc.b	"The I in TI means this.",0

Q91:	dc.b	"Opposite of day.",0

Q92:	dc.b	"Home of the Free and the land of the Brave.",0

Q93:	dc.b	"Virtual ______.",0

Ver:	dc.b	"Down",0

Q10:	dc.b	"Maker of this program.",0

Q11:	dc.b	"The ____ common denomenator.",0

Q12:	dc.b	"A show about 2 FBI agents investigating the",0

Q125:	dc.b	"          paranormal.",0

Q13:	dc.b	"Cars used to be made of this.",0

Q14:	dc.b	"The most accurate setting on the TI89.",0

Q15:	dc.b	"The derivitive of the sinx.",0

Q16:	dc.b	"An image on you PC that is a file.",0

Q17:	dc.b	"To undo the knots on a string.",0

Q18:	dc.b	"The button you hit to start a program on the 89",0

Q19:	dc.b	"The worst computer Apple has made.",0

Q20:	dc.b	"Sick or not well.",0


lettera:	dc.b	"A",0

letterb:	dc.b	"B",0

letterc:	dc.b	"C",0

letterd:	dc.b	"D",0

lettere:	dc.b	"E",0

letterf:	dc.b	"F",0

letterg:	dc.b	"G",0

letterh:	dc.b	"H",0

letteri:	dc.b	"I",0

letterj:	dc.b	"J",0

letterk:	dc.b	"K",0

letterl:	dc.b	"L",0

letterm:	dc.b	"M",0

lettern:	dc.b	"N",0

lettero:	dc.b	"O",0

letterp:	dc.b	"P",0

letterq:	dc.b	"Q",0

letterr:	dc.b	"R",0

letters:	dc.b	"S",0

lettert:	dc.b	"T",0

letteru:	dc.b	"U",0

letterv:	dc.b	"V",0

letterw:	dc.b	"W",0

letterx:	dc.b	"X",0

lettery:	dc.b	"Y",0

letterz:	dc.b	"Z",0

_comment:
	dc.b	"Crossword Puzzle by Bentensai",0

	end	